unit uOptions;
{$INCLUDE 'NewName.inc'}

interface

uses
  SysUtils, //Windows, Classes, Generics.Collections,
  {$IFDEF FAR3} Plugin3, {$ELSE} PluginW, {$ENDIF} FarKeysW, FarColor,
  uSystem, uFAR, uLog,
  uNewNameConsts;

type
  TNewNameOptions = class(TFarConfig)
  private
    fFileNamePattern: string;
    fStartingNumberAsString: string;
    fNoOddZeroes: boolean;
    function GetStartingNumberLength: integer;
    function GetStartingNumber: integer;
  protected
  public
    constructor Create;
    destructor Destroy; override;
    procedure Init;
    procedure Load;
    procedure Save;
    procedure Assign(Options: TNewNameOptions);
    property FileNamePattern: string read fFileNamePattern write fFileNamePattern;
    property StartingNumberAsString: string read fStartingNumberAsString write fStartingNumberAsString;
    property StartingNumber: integer read GetStartingNumber;
    property StartingNumberLength: integer read GetStartingNumberLength;
    property NoOddZeroes: boolean read fNoOddZeroes write fNoOddZeroes;
  end;

implementation

{ TDirSyncOptions }

procedure TNewNameOptions.Assign(Options: TNewNameOptions);
begin
  FileNamePattern := Options.FileNamePattern;
  StartingNumberAsString := Options.StartingNumberAsString;
  NoOddZeroes := Options.NoOddZeroes;
end;

constructor TNewNameOptions.Create;
begin
  inherited Create( {$IFDEF FAR3} PLUGIN_GUID {$ELSE} 'NewName' {$ENDIF} , False);
  Init;
end;

destructor TNewNameOptions.Destroy;
begin
  inherited;
end;

function TNewNameOptions.GetStartingNumber: integer;
begin
  Result := StrToInt(StartingNumberAsString);
end;

function TNewNameOptions.GetStartingNumberLength: integer;
begin
  Result := Length(StartingNumberAsString);
end;

procedure TNewNameOptions.Init;
begin
  fFileNamePattern := 'file%#.%e';
  fStartingNumberAsString := '0';
  fNoOddZeroes := False;
end;

procedure TNewNameOptions.Load;
begin
  if Open then begin
    FileNamePattern := ReadString('FileNameTemplate', FileNamePattern);
    StartingNumberAsString := ReadString('StartingNumber', StartingNumberAsString);
    NoOddZeroes := ReadBoolean('NoOddZeroes', NoOddZeroes);
  end;
end;

procedure TNewNameOptions.Save;
begin
  if Open then begin
    WriteString('FileNameTemplate', FileNamePattern);
    WriteString('StartingNumber', StartingNumberAsString);
    WriteBoolean('NoOddZeroes', NoOddZeroes);
  end;
end;

end.
